/*
 *******************************************************************
 * Project code name "ORCA"
 * 日医標準レセプトソフト（JMA standard receipt software）
 * Copyright(C) 2002 JMA (Japan Medical Association)
 *
 * This program is part of "JMA standard receipt software".
 *
 *     This program is distributed in the hope that it will be useful
 * for further advancement in medical care, according to JMA Open
 * Source License, but WITHOUT ANY WARRANTY.
 *     Everyone is granted permission to use, copy, modify and
 * redistribute this program, but only under the conditions described
 * in the JMA Open Source License. You should have received a copy of
 * this license along with this program. If not, stop using this
 * program and contact JMA, 2-28-16 Honkomagome, Bunkyo-ku, Tokyo,
 * 113-8621, Japan.
 ********************************************************************
 */

package drugstock.component;

import javax.swing.JComboBox;
import java.awt.Dimension;
 
public class WJComboBox extends JComboBox{ 

  public WJComboBox() {
  } 

  private boolean layout_stat = false;
                       
  public void layout_mode() {
    try {
      layout_stat = true;
      super.doLayout();
    } finally {
      layout_stat = false;
    }
  }
                           
  public Dimension getSize() {
    Dimension dim = super.getSize();
    if(layout_stat == false) {
      int w1 = dim.width;
      int w2 = getPreferredSize().width;
      dim.width = Math.max(w1, w2);
    }
    return dim;
  }
}
